"""Base parser for LAMMPS output."""

import time
import glob
import os
from typing import Any, Union

from aiida import orm
from aiida.parsers.parser import Parser
import numpy as np

from aiida_lammps.data.trajectory import LammpsTrajectory

from aiida_lammps.calculations.raw import LammpsRawCalculation
from aiida_lammps.parsers.parse_raw import parse_outputfile


class LammpsRawParser(Parser):
    """Base parser for LAMMPS output."""

    def parse(self, **kwargs):
        """Parse the contents of the output files stored in the ``retrieved`` output node."""
        retrieved = self.retrieved
        retrieved_filenames = retrieved.base.repository.list_object_names()
        filename_out = LammpsRawCalculation.FILENAME_OUTPUT

        if filename_out not in retrieved_filenames:
            return self.exit_codes.ERROR_OUTFILE_MISSING

        parsed_data = parse_outputfile(
            file_contents=retrieved.base.repository.get_object_content(filename_out)
        )
        if parsed_data is None:
            return self.exit_codes.ERROR_PARSING_OUTFILE
        
        # trajectory file
        trajectory_filename=self.node.get_option("trajectory_filename")
        if trajectory_filename in retrieved_filenames:
            with self.node.outputs.retrieved.base.repository.open(
                trajectory_filename
            ) as handle:
                lammps_trajectory = LammpsTrajectory(handle)
            self.out("trajectories", lammps_trajectory)
        
        # extra files (SIGEPS)
        extra_files_list=self.node.get_option("extra_filenames")
        if len(extra_files_list)>0:
            #from aiida_numodis.data.graph_output import LammpsStructureFiles
            extra_data=orm.Data()
        for filename in extra_files_list:
            if filename in retrieved_filenames:
                with self.node.outputs.retrieved.base.repository.open(
                filename
                ) as handle:
                    extra_data.base.repository.put_object_from_filelike(handle, filename)
        if len(extra_files_list)>0:
            self.out("extra_outputs", extra_data)

        # restart file
        restart_filename=self.node.get_option("restart_filename")
        if restart_filename in retrieved_filenames:
            parameters={"restart":{"print_final":True}}
            _restartfile_name = self.parse_restartfile(
                    parameters=parameters,
                    list_of_files=retrieved_filenames,
                    temp_folder=kwargs.get("retrieved_temporary_folder", None),
                )



        if parsed_data["global"]["errors"]:
            # Output the data for checking what was parsed
            self.out("results", orm.Dict({"compute_variables": parsed_data["global"]}))
            for entry in parsed_data["global"]["errors"]:
                self.logger.error(f"LAMMPS emitted the error {entry}")
                return self.exit_codes.ERROR_PARSER_DETECTED_LAMMPS_RUN_ERROR.format(
                    error=entry
                )

        global_data = parsed_data["global"]
        results = {"compute_variables": global_data}

        if "total_wall_time" in global_data:
            try:
                parsed_time = time.strptime(global_data["total_wall_time"], "%H:%M:%S")
            except ValueError:
                pass
            else:
                total_wall_time_seconds = (
                    parsed_time.tm_hour * 3600
                    + parsed_time.tm_min * 60
                    + parsed_time.tm_sec
                )
                global_data["total_wall_time_seconds"] = total_wall_time_seconds

        self.out("results", orm.Dict(results))

        return None
    def parse_restartfile(
        self,
        parameters: dict[str, Any],
        list_of_files: list[str],
        temp_folder: Union[os.PathLike, str, None],
    ) -> str:
        """
        Parse the restartfile generated by ``LAMMPS`` and store it as a node in the database.

        ``LAMMPS`` can produce several restartfiles, where some are written
        during the simulation at regular intervals, and another that is
        stored at the end of the simulation.

        This function tries to find which of those files are written by ``LAMMPS``
        and then store them in the database as ``orm.SinglefileData``.

        :param parameters: set of variables for the lammps script generation
        :type parameters: dict
        :param list_of_files: list of files retrieved
        :type list_of_files: list
        :param temp_folder: name of the temporary folder where the temporary retrieved are
        :type temp_folder: Union[os.PathLike, str, None]

        :return: Name of the found restartfile
        :rtype: str
        """
        input_restart_filename = self.node.get_option("restart_filename")

        restart_found = False

        restart_filename = ""

        if (
            parameters.get("restart", {}).get("print_final", False)
            and input_restart_filename in list_of_files
        ):
            with self.node.outputs.retrieved.base.repository.open(
                input_restart_filename,
                mode="rb",
            ) as handle:
                restart_file = orm.SinglefileData(handle)
            self.out("restartfile", restart_file)
            restart_found = True
            restart_filename = input_restart_filename

        if (
            parameters.get("restart", {}).get("print_intermediate", False)
            and not restart_found
            and temp_folder
        ):
            restartfiles = glob.glob(f"{temp_folder}/{input_restart_filename}*")

            if restartfiles:
                _files = []
                for entry in restartfiles:
                    try:
                        _files.append(
                            int(
                                entry.replace(
                                    f"{temp_folder}/{input_restart_filename}", ""
                                ).replace(".", "")
                            )
                        )
                    except ValueError:
                        _files.append(0)

                latest_file = os.path.basename(restartfiles[np.array(_files).argmax()])
                restart_filename = latest_file
                with open(os.path.join(temp_folder, latest_file), mode="rb") as handle:
                    restart_file = orm.SinglefileData(handle)
                self.out("restartfile", restart_file)
        return restart_filename
